%define ALD_Ver		1.2.1

Name:         glibc

License:      GPL
Summary:      The shared libraries (from the c-library-package)
Group:        System Environment/Libraries
Version:      2.17
Release:      1

Provides: rtld(GNU_HASH)
#Requires: %{OrgName} = %{version}

Source: %{name}-%{version}.tar.xz
Source1: CROSS.sh
Source2: glibc-MAKE.zoneinfo
Patch0: glibc-2.17-arm_dl.patch
#Source3: %{name}-ports-%{version}.tar.xz
#Patch0: glibc-2.12.2.patch

%define DestDir		/System/glibc/%{version}

# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif


%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os} 
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif
%define target_  %{target}-

%define crossdir	/cross
%define csysdir		%{crossdir}/%{TO_ARCH}
%define csysbindir	%{csysdir}/bin

%define __os_install_post %{nil}

%define cross_bindir	%{csysdir}%{_bindir}
%define cross_sbindir	%{csysdir}%{_sbindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir %{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir		%{nil}
%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir %{_topdir}/SRPMS/%{ALD_Ver}

%define target_  %{nil}
%define target %{_build}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{name}

%define i18charmaps %{_datadir}/i18n/charmaps
%define i18locales %{_datadir}/i18n/locales
%define gconvmod %{_libdir}/gconv

# ------------------- description ------------------------------------
%description
Shared C libraries - needed to run programs linked with
libc and libm,... libraries
# -------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel
These libraries are needed to compile C code.
# -------------------
%package staticlib
Summary:      Static libraries
Group:        Development/Libraries
%description staticlib
Static libraries for %{name}
#-------------------------------
%package info
Summary:      Info for %{name}
Group:        Documentation
%description info
Info for %{name}
#-------------------------------
%package locale
Summary:      locale
Group:        Applications/Languages
%description locale
Locale
#-------------------------------
%package i18n-all
Summary:      Database Sources for 'locale'
Group:        System/Libraries
%description i18n-all
This package contains the data needed to build the locale data files to
use the internationalization features of the GNU libc.

#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries
# --------------------------------------
%package %{TO_ARCH}-staticlib
Summary:      %{name} Cross-%{TO_ARCH} static Libraries
Group:        Development/Libraries
%description %{TO_ARCH}-staticlib
%{name} Cross-%{TO_ARCH} static Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}
%ifarch %{arm}
%patch0 -b .orig -p0
%endif


%if %{_CROSS}
sed -i s:"\$(localedir)":"%{_libdir}/locale": locale/Makefile
%endif
sed -i s:"(cross-compiling),no":"(cross-compiling),nie": timezone/Makefile

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2"
%endif
%if %{_arch} == "arm"
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU}"
%endif

CXXFLAGS="$OPTFLAGS"
CFLAGS="$OPTFLAGS -DNDEBUG=1 -std=gnu99"
LDFLAGS=" "

export CFLAGS CXXFLAGS LDFLAGS CC CPP

%if 0
#if %{BUILD_LOCAL_CROSS}
libc_cv_rootsbindir="/sbin"
libc_cv_slibdir="%{csysdir}/%{_lib}"
export libc_cv_rootsbindir libc_cv_slibdir
%endif

mkdir zz
cd zz

../configure \
%if %{_CROSS}
	--build=%{_build} \
	--host=%{target} \
%else
%if %{_arch} == "i386"
	--build=i586-pc-linux-gnu --host=i586-pc-linux-gnu \
%endif
%endif
%if %{_CROSS}
	--with-headers=%{csysdir}/usr/include \
%else
	--with-headers=/usr/src/linux/include \
%endif
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
	--infodir=%{_infodir} \
	--sysconfdir=%{_sysconfdir} \
	--enable-add-ons=nptl,libidn \
	--enable-shared \
	--with-fp \
	--with-elf \
	--without-selinux \
	--without-xcoff \
	--without-cvs \
	--with-tls \
	--with-__thread \
	--enable-bind-now \
	--disable-profile \
%if %{_arch} == "arm"
	--enable-kernel=2.6.32 \
	--enable-add-ons=ports,nptl \
%else
%if %{_arch} == "x86_64"
	--enable-kernel=2.6.16 \
	--enable-oldest-abi=2.2 \
%else
	--enable-kernel=2.4.1 \
	--enable-oldest-abi=2.0 \
%endif
%endif
	&>FConfigure_log.txt

make -j2 &>FMake_log.txt
cd ..

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
export PATH
%else
export PATH=$PATH:/opt/perl/bin
%endif


rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/zoneinfo

(cd zz; make -j2 install_root=$RPM_BUILD_ROOT install &>Finstall_log.txt)

cp COPYING COPYING.LIB LICENSES README $RPM_BUILD_ROOT%{docdir}/
rm -rf $RPM_BUILD_ROOT%{_infodir}/dir

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=%{BUILD_LOCAL_CROSS}
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
rm -r $RPM_BUILD_ROOT%{csysdir}/etc
rm -r $RPM_BUILD_ROOT%{csysdir}/sbin
rm -r $RPM_BUILD_ROOT%{cross_bindir}
rm -r $RPM_BUILD_ROOT%{cross_sbindir}
rm -r $RPM_BUILD_ROOT%{cross_libdir}/audit
rm -r $RPM_BUILD_ROOT%{cross_libdir}/gconv
rm -r $RPM_BUILD_ROOT%{cross_libdir}/getconf
rm $RPM_BUILD_ROOT%{cross_libdir}/pt_chown
rm -r $RPM_BUILD_ROOT%{cross_infodir}
rm -r $RPM_BUILD_ROOT%{cross_datadir}/i18n
rm -r $RPM_BUILD_ROOT%{cross_datadir}/locale
rm -r $RPM_BUILD_ROOT%{cross_datadir}/zoneinfo
rm -r $RPM_BUILD_ROOT%{csysdir}/var

pushd $RPM_BUILD_ROOT%{cross_libdir}
  sed -i s:" /%{_lib}/":" %{csysdir}/%{_lib}/": libc.so
  sed -i s:" /%{_lib}/":" %{csysdir}/%{_lib}/": libc.so
  sed -i s:" /usr/%{_lib}/":" %{csysdir}/usr/%{_lib}/": libc.so
  sed -i s:" /%{_lib}/":" %{csysdir}/%{_lib}/": libpthread.so
  sed -i s:" /usr/%{_lib}/":" %{csysdir}/usr/%{_lib}/": libpthread.so
popd
%endif #_CROSS


rm -rf $RPM_BUILD_ROOT/sbin/sln

mkdir -p $RPM_BUILD_ROOT/etc/defaults
cp nscd/nscd.conf $RPM_BUILD_ROOT/etc/defaults/

mkdir -p $RPM_BUILD_ROOT%{_libdir}/locale
cp localedata/README localedata/SUPPORTED $RPM_BUILD_ROOT%{_libdir}/locale

%if 1
cd timezone
cp africa antarctica asia australasia europe northamerica \
	southamerica pacificnew etcetera factory backward systemv \
	solar87 solar88 solar89 leapseconds yearistype \
	$RPM_BUILD_ROOT%{_datadir}/zoneinfo/
cd ..
cp %SOURCE2 $RPM_BUILD_ROOT%{_datadir}/zoneinfo/MAKE.zoneinfo
%endif #_CROSS

# ------------------- Clean ------------------------------------------
%Clean
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-devel-$SE $DD/%{name}-devel-$DE
  mv %{name}-staticlib-$SE $DD/%{name}-staticlib-$DE
  mv %{name}-info-$SE $DD/%{name}-info-$DE
  mv %{name}-locale-$SE $DD/%{name}-locale-$DE
  mv %{name}-i18n-all-$SE $DD/%{name}-i18n-all-$DE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
  mv %{name}-%{TO_ARCH}-staticlib-$SE $DDC/%{name}-%{TO_ARCH}-staticlib-$DEC
%endif #BUILD_LOCAL_CROSS
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r etc %{_lib} sbin usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%if %{BUILD_LOCAL_CROSS}
  TMP_TO=$DDC/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{TO_ARCH}-%{version}-%{release}.%{_build_cpu}
  mkdir -p $tmp
  cp -r cross $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%endif
popd
%endif  #BUILD_TAR

# ------------------- post ------------------------------------------
%post
if [ ! -e /etc/ld.so.conf ]; then
  echo "/usr/X11/%{_lib}" >/etc/ld.so.conf
fi

/sbin/ldconfig
#localedef -i en_US -f ISO-8859-1 en_US
#localedef -i en_US -f UTF-8 en_US.UTF-8
#localedef -i de_DE -f ISO-8859-1 de_DE
#localedef -i de_DE@euro -f ISO-8859-15 de_DE@euro
#localedef -i de_DE -f UTF-8 de_DE.UTF-8

if [ ! -e /etc/nscd.conf ]; then
  cp /etc/defaults/nscd.conf /etc/nscd.conf
fi

#if [ ! -e /lib/ld-linux.so.3 ]; then
#  pushd /lib >/dev/null
#  ln -s ld-2.17.so ld-linux.so.3
#  popd >/dev/null
#fi

#if [ ! -e /etc/localtime ]; then
#  zic -l UTC
#fi

#preun
##localedef --delete-from-archive en_US
#rm -f /usr/lib64/locale/locale-archive

%post info
if test -f /usr/bin/install-info; then
  for i in libc.info libc.info-1 libc.info-2 libc.info-3 libc.info-4 libc.info-5 libc.info-6 libc.info-7 libc.info-8 libc.info-9 libc.info-10 libc.info-11; do
    /usr/bin/install-info --info-dir=/usr/share/info --info-file=/usr/share/info/$i
  done
fi
%preun info
if test -f /usr/bin/install-info -a ! -f /usr/share/info/libc.info; then
  for i in libc.info libc.info-1 libc.info-2 libc.info-3 libc.info-4 libc.info-5 libc.info-6 libc.info-7 libc.info-8 libc.info-9 libc.info-10 libc.info-11; do
    /usr/bin/install-info --delete --info-dir=/usr/share/info --info-file=/usr/share/info/$i
  done
fi

# ------------------- Files ------------------------------------------
%Files
/etc
/sbin/ldconfig
/%{_lib}
%{_bindir}/gencat
%{_bindir}/getconf
%{_bindir}/getent
%{_bindir}/iconv
%{_bindir}/ldd*
%{_bindir}/locale
%{_bindir}/localedef
%{_bindir}/makedb
%{_bindir}/pldd
%{_bindir}/tzselect
%{_sbindir}
%{_libdir}/getconf
%{_libdir}/locale
%{_libdir}/pt_chown
%{gconvmod}/ISO8859-1.so
%{gconvmod}/ISO8859-15.so
%{gconvmod}/UNICODE.so
%{gconvmod}/UTF-16.so
%{gconvmod}/UTF-32.so
%{gconvmod}/gconv-modules
%{i18charmaps}/ISO-8859-1.gz
%{i18charmaps}/ISO-8859-15.gz
%{i18charmaps}/UTF-8.gz
%{i18locales}/POSIX
%{i18locales}/de_DE
%{i18locales}/de_DE@euro
%{i18locales}/en_GB
%{i18locales}/en_US
%{i18locales}/fr_FR
%{i18locales}/fr_FR@euro
%{i18locales}/it_IT
%{i18locales}/it_IT@euro
%{i18locales}/nl_NL
%{i18locales}/nl_NL@euro
%{i18locales}/i18n
%{i18locales}/iso14651_t1
%{i18locales}/iso14651_t1_common
%{i18locales}/translit_circle
%{i18locales}/translit_cjk_compat
%{i18locales}/translit_combining
%{i18locales}/translit_compat
%{i18locales}/translit_font
%{i18locales}/translit_fraction
%{i18locales}/translit_narrow
%{i18locales}/translit_neutral
%{i18locales}/translit_small
%{i18locales}/translit_wide
%{_datadir}/zoneinfo
%{docdir}
/var

%files staticlib
%exclude %{_libdir}/libc_nonshared.a
%exclude %{_libdir}/libpthread_nonshared.a
%{_libdir}/*.a


%files devel
%{_libdir}/*.o
%{_libdir}/*.so
%{_libdir}/audit
%{_libdir}/libc_nonshared.a
%{_libdir}/libpthread_nonshared.a
%{_includedir}
%{_bindir}/catchsegv
%{_bindir}/mtrace
%{_bindir}/pcprofiledump
%{_bindir}/rpcgen
%{_bindir}/sotruss
%{_bindir}/sprof
%{_bindir}/xtrace

%files info
%{_datadir}/info

%files locale
%{_datadir}/locale

%files i18n-all
%{gconvmod}
%exclude %{gconvmod}/ISO8859-1.so
%exclude %{gconvmod}/ISO8859-15.so
%exclude %{gconvmod}/UNICODE.so
%exclude %{gconvmod}/UTF-16.so
%exclude %{gconvmod}/UTF-32.so
%exclude %{gconvmod}/gconv-modules
%{i18charmaps}
%exclude %{i18charmaps}/ISO-8859-1.gz
%exclude %{i18charmaps}/ISO-8859-15.gz
%exclude %{i18charmaps}/UTF-8.gz
%{i18locales}
%exclude %{i18locales}/POSIX
%exclude %{i18locales}/de_DE
%exclude %{i18locales}/de_DE@euro
%exclude %{i18locales}/en_GB
%exclude %{i18locales}/en_US
%exclude %{i18locales}/fr_FR
%exclude %{i18locales}/fr_FR@euro
%exclude %{i18locales}/it_IT
%exclude %{i18locales}/it_IT@euro
%exclude %{i18locales}/nl_NL
%exclude %{i18locales}/nl_NL@euro
%exclude %{i18locales}/i18n
%exclude %{i18locales}/iso14651_t1
%exclude %{i18locales}/iso14651_t1_common
%exclude %{i18locales}/translit_circle
%exclude %{i18locales}/translit_cjk_compat
%exclude %{i18locales}/translit_combining
%exclude %{i18locales}/translit_compat
%exclude %{i18locales}/translit_font
%exclude %{i18locales}/translit_fraction
%exclude %{i18locales}/translit_narrow
%exclude %{i18locales}/translit_neutral
%exclude %{i18locales}/translit_small
%exclude %{i18locales}/translit_wide

%if %{BUILD_LOCAL_CROSS}
%Files %{TO_ARCH}
%{csysdir}/%{_lib}
%{cross_libdir}/*.o
%{cross_libdir}/*.so
%{cross_libdir}/libc_nonshared.a
%{cross_libdir}/libpthread_nonshared.a
%{cross_includedir}
%{cross_docdir}

%Files %{TO_ARCH}-staticlib
%exclude %{cross_libdir}/libc_nonshared.a
%exclude %{cross_libdir}/libpthread_nonshared.a
%{cross_libdir}/*.a
%endif #BUILD_LOCAL_CROSS
